jQuery(document).ready(function($) {

    //apply chosen
    jQuery("#dagt-enumerate").chosen();

      //Cancel button handler
      $('#cancel').click(function(event) {

        //reload the Autolinks menu
        event.preventDefault();
        window.location.replace(window.dagt_admin_url + 'admin.php?page=dagt-sections');

      });

    //create an object of the modal window class
    var dagp_modal = new dagp_modal_window;

    //event listener missing word modal window
    $('.dagp-nmw-modal-window').click(function(){
       
        //get the sentence id
        var sentence_id = parseInt($(this).attr('data-id'));
        
        //get the caret position ( in the sentence )
        var caret_position = doGetCaretPosition(document.getElementById("sentence" + sentence_id));

        //get the modal window content
        var modal_content = get_modal_content(this);

        //do not generate the modal window if there is an error in the response
        if(modal_content == "error"){return;}

        //create the modal window
        dagp_modal.create(298, 320, modal_content);
        
        //#nmw-submit-button event listener
        $('#nmw-submit-button').click(function(){
            save_missing_word(sentence_id, caret_position);
        });
        
        //apply chosen
        $("#nmw-case-insensitive").chosen();
        
    });
    
    //event listener edit missing word modal window
    $('.dagp-emw-modal-window').click(function(){
       
        //store the this value
        var this_element = $(this);
       
        //get the sentence id
        var sentence_id = parseInt($(this).attr('data-id'));
        
        //get the sentence content
        var sentence_content = $('#sentence' + sentence_id).val();
        
        //verify if there are valid missing words to edit
        var regexp = /\[mw\s+id="(\d+)"\]/ig;
        var mw_id_a = new Array();
        var match = regexp.exec(sentence_content);
        
        while(match !== null){
            mw_id_a.push(match[1]);
            match = regexp.exec(sentence_content);
        }
        
        /*
         * Verify if there is at least 1 valid mw id in mw_id_a array with an
         * ajax request. If there is at least 1 valid mw id activate the mw edit
         * icon otherwise deactivate the icon
         */
        var data = {
            "action": "dagt_get_number_of_valid_mw_ids",
            "security": dagt_nonce,
            "mw_id_a": mw_id_a
        };
        
        //send ajax request
        $.ajaxSetup({async: false});
        $.post(dagt_ajax_url, data, function(number_of_valid_mw_ids) {
            
            if(number_of_valid_mw_ids > 0){

                //get the caret position ( in the sentence )
                var caret_position = doGetCaretPosition(document.getElementById("sentence" + sentence_id));

                //get the modal window content
                var modal_content = get_modal_content(this_element, sentence_content);

                //do not generate the modal window if there is an error in the response
                if(modal_content == "error"){return;}

                //create the modal window
                dagp_modal.create(298, 392, modal_content);

                //#emw-submit-button event listener
                $('#emw-submit-button').click(function(){
                    update_missing_word(sentence_id, caret_position);
                });

                /*
                 * #emw-missing-word-id event listener
                 * 
                 * Change the values of the fields with an ajax request when a missing
                 * word id is selected through the #emw-missing-word-id select box
                 */
                $('#emw-missing-word-id').change(function(){

                    //get the id of the current selection
                    var missing_word_id = $(this).val();

                    //prepare the ajax request data
                    var data = {
                        "action": "dagt_update_missing_word_fields",
                        "security": dagt_nonce,
                        "missing_word_id": missing_word_id
                    };

                    //execute the ajax request
                    $.post(dagt_ajax_url, data, function(results_json) {

                        var data_obj = jQuery.parseJSON(results_json);

                        //update the fields
                        $('#emw-missing-word-id').val(data_obj.id);
                        $('#emw-correct-answer').val(data_obj.correct_answer);
                        $('#emw-explanation').val(data_obj.explanation);

                        /*
                         * Update the select and trigger the proper chosen event that
                         * updates the chosen select
                         */
                        $('#emw-case-insensitive').val(data_obj.case_insensitive);
                        $('#emw-case-insensitive').trigger("chosen:updated");

                    });

                });

                //apply chosen
                $('#emw-missing-word-id, #emw-case-insensitive').chosen();

            }
            
        });
        
    });
    
    //event listener new multiple selection modal window
    $('.dagp-nms-modal-window').click(function(){
       
        //get the sentence id
        var sentence_id = parseInt($(this).attr('data-id'));
        
        //get the caret position ( in the sentence )
        var caret_position = doGetCaretPosition(document.getElementById("sentence" + sentence_id));

        //get the modal window content
        var modal_content = get_modal_content(this);

        //do not generate the modal window if there is an error in the response
        if(modal_content == "error"){return;}

        //create the modal window
        dagp_modal.create(298, 608, modal_content);
        
        //#nms-submit-button event listener
        $('#nms-submit-button').click(function(){
            save_multiple_selection(sentence_id, caret_position);
        });
        
        //apply chosen
        $('#nms-correct-answer').chosen();
        
    });
    
    //event listener edit multiple selection modal window
    $('.dagp-ems-modal-window').click(function(){
       
        //store the this value
        var this_element = $(this);
       
        //get the sentence id
        var sentence_id = parseInt($(this).attr('data-id'));
        
        //get the sentence content
        var sentence_content = $('#sentence' + sentence_id).val();
        
        //verify the presence of a multiple selection in the sentence
        var regexp = /\[ms\s+id="(\d+)"\]/ig;
        var ms_id_a = new Array();
        var match = regexp.exec(sentence_content);
        
        while(match !== null){
            ms_id_a.push(match[1]);
            match = regexp.exec(sentence_content);
        }
        /*
         * Verify if there is at least 1 valid ms id in ms_id_a array with an
         * ajax request. If there is at least 1 valid ms id activate the ms edit
         * icon otherwise deactivate the icon
         */
        var data = {
            "action": "dagt_get_number_of_valid_ms_ids",
            "security": dagt_nonce,
            "ms_id_a": ms_id_a
        };
        
        //send ajax request
        jQuery.ajaxSetup({async: false});
        $.post(dagt_ajax_url, data, function(number_of_valid_ms_ids) {
        
            if(number_of_valid_ms_ids > 0){

                //get the caret position ( in the sentence )
                var caret_position = doGetCaretPosition(document.getElementById("sentence" + sentence_id));

                //get the modal window content
                var modal_content = get_modal_content(this_element, sentence_content);

                //do not generate the modal window if there is an error in the response
                if(modal_content == "error"){return;}

                //create the modal window
                dagp_modal.create(298, 680, modal_content);

                //#ems-submit-button event listener
                $('#ems-submit-button').click(function(){
                    update_multiple_selection(sentence_id, caret_position);
                });

                /*
                 * #emw-multiple-selection-id event listener
                 * 
                 * Change the values of the fields with an ajax request when a multiple
                 * selection id is selected through the #ems-multiple-selection-id
                 * select box
                 */
                $('#ems-multiple-selection-id').change(function(){

                    //get the id of the current selection
                    var multiple_selection_id = $(this).val();

                    //prepare the ajax request data
                    var data = {
                        "action": "dagt_update_multiple_selection_fields",
                        "security": dagt_nonce,
                        "multiple_selection_id": multiple_selection_id
                    };

                    //execute the ajax request
                    $.post(dagt_ajax_url, data, function(results_json) {

                        var data_obj = jQuery.parseJSON(results_json);

                        //update the fields
                        $('#ems-multiple-selection-id').val(data_obj.id);
                        $('#ems-alternative-1').val(data_obj.alternative_1);
                        $('#ems-alternative-2').val(data_obj.alternative_2);
                        $('#ems-alternative-3').val(data_obj.alternative_3);
                        $('#ems-alternative-4').val(data_obj.alternative_4);
                        $('#ems-alternative-5').val(data_obj.alternative_5);
                        $('#ems-explanation').val(data_obj.explanation);

                        /*
                         * Update the select and trigger the proper chosen event that
                         * updates the chosen select
                         */
                        $('#ems-correct-answer').val(data_obj.correct_answer);
                        $('#ems-correct-answer').trigger("chosen:updated");

                    });

                });

                //apply chosen
                $('#ems-correct-answer, #ems-multiple-selection-id').chosen();

            }
            
        });
        
    });
    
    /*
     * Get the content of the modal window
     */
    function get_modal_content(caller_obj, sentence_content){
        
        var caller_obj_class = $(caller_obj).attr('class');
        
        //prepare input for the ajax request
        switch( caller_obj_class ) {
            
            case 'dagp-nmw-modal-window':
                
                var data = {
                    "action": "dagt_generate_nmw_modal_window",
                    "security": dagt_nonce
                };
                
                break;
                
            case 'dagp-emw-modal-window':
                
                var data = {
                    "action": "dagt_generate_emw_modal_window",
                    "security": dagt_nonce,
                    "sentence_content": sentence_content
                };
                
                break;
                
            case 'dagp-nms-modal-window':
                
                var data = {
                    "action": "dagt_generate_nms_modal_window",
                    "security": dagt_nonce
                };
                
                break;
                
            case 'dagp-ems-modal-window':
                
                var data = {
                    "action": "dagt_generate_ems_modal_window",
                    "security": dagt_nonce,
                    "sentence_content": sentence_content
                };
                
                break;
                
        }
        
        var modal_content;

        //ajax
        jQuery.ajaxSetup({async: false});
        $.post(dagt_ajax_url, data, function(response) {
            modal_content = response;
        });
        
        return modal_content;
        
    }
    
    /*
     * Save a missing word created with the "Add Missing Word" modal window
     */
    function save_missing_word(sentence_id, caret_position){
        
        //get data from the form
        var missing_word_id = parseInt($('#nmw-missing-word-id').val(), 10);
        var correct_answer = $('#nmw-correct-answer').val();
        var case_insensitive = parseInt($('#nmw-case-insensitive').val(), 10);
        var explanation = $('#nmw-explanation').val();
        
        //prepare ajax request
        var data = {
            "action": "dagt_save_missing_word",
            "security": dagt_nonce,
            "missing_word_id": missing_word_id,
            "correct_answer": correct_answer,
            "case_insensitive": case_insensitive,
            "explanation": explanation
        };

        //send ajax request
        $.post(dagt_ajax_url, data, function(saved_missing_word_id) {
           
            if(saved_missing_word_id !== 'error'){

                //shortcode
                var shortcode = '[mw id="' + saved_missing_word_id + '"]';

                /*
                 * Put the missing word icon in the sentence near the button
                 * used to call the missing word modal window
                 */
                var old_sentence = $('#sentence' + sentence_id).val();
                var new_sentence = old_sentence.substring(0, caret_position) + shortcode + old_sentence.substring(caret_position, old_sentence.length);
                $('#sentence' +  sentence_id).val(new_sentence);
                
                /*
                 * Trigger the 'input' event so that the content of the sentence
                 * will be verified and the edit button enabled or disabled
                 */
                $('#sentence' +  sentence_id).trigger( "input" );

            }

            //close the modal window
            dagp_modal.close();
            
        });
        
    }
    
    /*
     * Update a missing word modified with the "Update Missing Word" modal window
     */
    function update_missing_word(sentence_id, caret_position){
        
        //get data from the form
        var missing_word_id = parseInt($('#emw-missing-word-id').val(), 10);
        var correct_answer = $('#emw-correct-answer').val();
        var case_insensitive = parseInt($('#emw-case-insensitive').val(), 10);
        var explanation = $('#emw-explanation').val();
        
        //save data to the database with an AJAX request
        //prepare ajax request
        var data = {
            "action": "dagt_update_missing_word",
            "security": dagt_nonce,
            "missing_word_id": missing_word_id,
            "correct_answer": correct_answer,
            "case_insensitive": case_insensitive,
            "explanation": explanation
        };

        //send ajax request
        $.post(dagt_ajax_url, data, function(updated_missing_word_id) {
           
            if(updated_missing_word_id !== 'error'){

            }

            //close the modal window
            dagp_modal.close();
            
        });
        
    }
    
    /*
     * Save a multiple selection created with the "Add Multiple Selection"
     * modal window
     */
    function save_multiple_selection(sentence_id, caret_position){
        
        //get data from the form
        var multiple_selection_id = parseInt($('#nms-multiple-selection-id').val(), 10);
        var alternative_1 = $('#nms-alternative-1').val();
        var alternative_2 = $('#nms-alternative-2').val();
        var alternative_3 = $('#nms-alternative-3').val();
        var alternative_4 = $('#nms-alternative-4').val();
        var alternative_5 = $('#nms-alternative-5').val();
        var correct_answer = $('#nms-correct-answer').val();
        var explanation = $('#nms-explanation').val();
        
        //prepare ajax request
        var data = {
            "action": "dagt_save_multiple_selection",
            "security": dagt_nonce,
            "multiple_selection_id": multiple_selection_id,
            "alternative_1": alternative_1,
            "alternative_2": alternative_2,
            "alternative_3": alternative_3,
            "alternative_4": alternative_4,
            "alternative_5": alternative_5,
            "correct_answer": correct_answer,
            "explanation": explanation
        };

        //send ajax request
        $.post(dagt_ajax_url, data, function(saved_multiple_selection_id) {
           
            if(saved_multiple_selection_id !== 'error'){

                //shortcode
                var shortcode = '[ms id="' + saved_multiple_selection_id + '"]';

                /*
                 * Put the multiple selection shortcode in the sentence near at
                 * the caret position used to create the missing word
                 */
                var old_sentence = $('#sentence' + sentence_id).val();
                var new_sentence = old_sentence.substring(0, caret_position) + shortcode + old_sentence.substring(caret_position, old_sentence.length);
                $('#sentence' +  sentence_id).val(new_sentence);
                
                /*
                 * Trigger the 'input' event so that the content of the sentence
                 * will be verified and the edit button enabled or disabled
                 */
                $('#sentence' +  sentence_id).trigger( "input" );

            }

            //close the modal window
            dagp_modal.close();
            
        });
        
    }
    
    /*
     * Update a multiple selection modified through the "Edit Multiple Selection"
     * modal window
     */
    function update_multiple_selection(sentence_id, caret_position){
        
        //get data from the form
        var multiple_selection_id = parseInt($('#ems-multiple-selection-id').val(), 10);
        var alternative_1 = $('#ems-alternative-1').val();
        var alternative_2 = $('#ems-alternative-2').val();
        var alternative_3 = $('#ems-alternative-3').val();
        var alternative_4 = $('#ems-alternative-4').val();
        var alternative_5 = $('#ems-alternative-5').val();
        var correct_answer = $('#ems-correct-answer').val();
        var explanation = $('#ems-explanation').val();
        
        //save data to the database with an AJAX request
        //prepare ajax request
        var data = {
            "action": "dagt_update_multiple_selection",
            "security": dagt_nonce,
            "multiple_selection_id": multiple_selection_id,
            "alternative_1": alternative_1,
            "alternative_2": alternative_2,
            "alternative_3": alternative_3,
            "alternative_4": alternative_4,
            "alternative_5": alternative_5,
            "correct_answer": correct_answer,
            "explanation": explanation
        };

        //send ajax request
        $.post(dagt_ajax_url, data, function(saved_multiple_selection_id) {
           
            if(saved_multiple_selection_id !== 'error'){

            }

            //close the modal window
            dagp_modal.close();
            
        });
        
    }

    /*
    * Returns the caret (cursor) position of the specified text field.
    * Return value range is 0-oField.value.length.
    */
    function doGetCaretPosition (oField) {

      // Initialize
      var iCaretPos = 0;

      // IE Support
      if (document.selection) {

        // Set focus on the element
        oField.focus();

        // To get cursor position, get empty selection range
        var oSel = document.selection.createRange();

        // Move selection start to 0 position
        oSel.moveStart('character', -oField.value.length);

        // The caret position is selection length
        iCaretPos = oSel.text.length;
      }

      // Firefox support
      else if (oField.selectionStart || oField.selectionStart == '0')
        iCaretPos = oField.selectionStart;

      // Return results
      return iCaretPos;
    }
    
    /*
     * The dagp_modal_window class is used to generate the modal window
     */
    function dagp_modal_window(){

        this.width = "";
        this.height = "";
        this.content = "";

        this.create = function create(width, height, content){

            this.width = width;
            this.height = height;
            this.content = content;

            this.add_mask();
            this.add_modal_window();
            this.add_style();
            jQuery('.dagp-modal-window').fadeIn();

            //move the modal window on the center on window resize event
            jQuery(window).resize(function(){

                var left_pos = ( jQuery(window).width() - width ) / 2;
                var top_pos = ( jQuery(window).height() - height ) / 2;

                jQuery('.dagp-modal-window').css({
                    'left': left_pos,
                    'top': top_pos
                });

            });

        };

        /**
         * Add styles to the html markup
         */
        this.add_style = function add_style(){

            var left_pos = ( jQuery(window).width() - this.width ) / 2;
            var top_pos = ( jQuery(window).height() - this.height ) / 2;

            jQuery('.dagp-modal-window').css({
                'position':'absolute',
                'left': left_pos,
                'top': top_pos,
                'display':'none',
                'width': this.width + 'px',
                'height': this.height + 'px',
                'z-index':'999999992',
                'box-shadow': '0 3px 6px rgba(0,0,0,.3)',
                '-webkit-box-shadow': '0 3px 6px rgba(0,0,0,.3)'
            });

            jQuery('.dagp-modal-close').css({
                'position':'absolute',
                'top':'-12px',
                'right':'-12px',
                'display':'block',
                'height':'32px',
                'width':'32px',
                'z-index':'999999993'
            });
            jQuery('.dagp-mask').css({
                'position':'fixed',
                'top':'0',
                'left':'0',
                'background-color':'rgba(170,170,170,0.3)',
                'height':'100%',
                'width':'100%',
                'z-index':'999999991'
            });
        };

        /**
         * Create the block page div
         */
        this.add_mask = function add_mask(){
            var block_page = jQuery('<div class="dagp-mask"></div>');
            jQuery(block_page).appendTo('body');
        };

        /**
         * Creates the modal box
         */
        this.add_modal_window = function add_modal_window(){
            var pop_up = jQuery('<div class="dagp-modal-window">' + this.content + '</div>');
            jQuery(pop_up).appendTo('.dagp-mask');

            jQuery('.dagt-menu-head-close').click(function(){
                jQuery(this).parent().fadeOut().remove();
                jQuery('.dagp-mask').fadeOut().remove();
            });
        };

        /**
         * Close the modal box
         */
        this.close = function close(){

            jQuery('.dagp-modal-window').fadeOut().remove();
            jQuery('.dagp-mask').fadeOut().remove();

        };

    };
    
    /*
     * Enable or Disable the "Edit Missing Word" and the "Edit Multiple
     * Selection" buttons if there are or there are not reference to existing
     * missing word of multiple selection in the sentence
     */
    $('.dagt-sentence').on('input', function() {
        
        //verify the presence of a missing word in the sentence
        var caller_element = $(this);
        var regexp = /\[mw\s+id="(\d+)"\]/ig;
        var mw_id_a = new Array();
        var sentence_content = $(this).val();
        var match = regexp.exec(sentence_content);
        
        while(match !== null){
            mw_id_a.push(match[1]);
            match = regexp.exec(sentence_content);
        }
        
        if(mw_id_a.length > 0){

            //set a blue icon
            var icon_parent_id = caller_element.parent().attr('id');
            $('#' + icon_parent_id + ' .dagp-emw-modal-window').removeClass('dagt-emw-greyed');

            /*
             * Set a data attribute that will be used to open or not the modal
             * window in the function associated with its event listener
             */
            caller_element.attr('data-mw-edit-enabled', '1');

        }else{

            //set a grey icon
            var icon_parent_id = caller_element.parent().attr('id');
            $('#' + icon_parent_id + ' .dagp-emw-modal-window').addClass('dagt-emw-greyed');

            /*
             * Set a data attribute that will be used to open or not the modal
             * window in the function associated with its event listener
             */
            caller_element.attr('data-mw-edit-enabled', '0');

        }
            
        //verify the presence of a multiple selection in the sentence
        var regexp = /\[ms\s+id="(\d+)"\]/ig;
        var ms_id_a = new Array();
        var match = regexp.exec(sentence_content);
        
        while(match !== null){
            ms_id_a.push(match[1]);
            match = regexp.exec(sentence_content);
        }
        
        if(ms_id_a.length > 0){

            //set a blue icon
            var icon_parent_id = caller_element.parent().attr('id');
            $('#' + icon_parent_id + ' .dagp-ems-modal-window').removeClass('dagt-ems-greyed');

        }else{

            //set a grey icon
            var icon_parent_id = caller_element.parent().attr('id');
            $('#' + icon_parent_id + ' .dagp-ems-modal-window').addClass('dagt-ems-greyed');

        }
        
    });
    
});