<?php

        if ( !current_user_can( 'manage_options' ) )  {
            wp_die( esc_attr__( 'You do not have sufficient capabilities to access this page.' ) );
        }

        ?>

        <div class="wrap">
            
            <h2><?php esc_attr_e('Grammar Test - Options', 'dagt'); ?></h2>

            <?php

            //settings errors
            if( isset($_GET['settings-updated']) and $_GET['settings-updated'] == 'true' ){
                if( $this->shared->write_custom_css() === false ){
                    ?>
                    <div id="setting-error-settings_updated" class="error settings-error notice is-dismissible below-h2">
                        <p><strong>The <?php echo $this->shared->get('dir') . 'public/assets/css/custom-' . get_current_blog_id() . '.css'; ?> file should be writable by the server.  Please change its permissions and try again.</strong></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button>
                    </div>
                    <?php
                }
                settings_errors();
            }

            ?>

            <div id="daext-options-wrapper">

                <?php
                //get current tab value
                $active_tab = isset( $_GET[ 'tab' ] ) ? $_GET[ 'tab' ] : 'typography_options';
                ?>

                <div class="nav-tab-wrapper">
                    <a href="?page=dagt-options&tab=typography_options" class="nav-tab <?php echo $active_tab == 'typography_options' ? 'nav-tab-active' : ''; ?>"><?php esc_attr_e('Typography', 'dagt'); ?></a>
                    <a href="?page=dagt-options&tab=colors_options" class="nav-tab <?php echo $active_tab == 'colors_options' ? 'nav-tab-active' : ''; ?>"><?php esc_attr_e('Colors', 'dagt'); ?></a>
                    <a href="?page=dagt-options&tab=labels_options" class="nav-tab <?php echo $active_tab == 'labels_options' ? 'nav-tab-active' : ''; ?>"><?php esc_attr_e('Labels', 'dagt'); ?></a>
                    <a href="?page=dagt-options&tab=advanced_options" class="nav-tab <?php echo $active_tab == 'advanced_options' ? 'nav-tab-active' : ''; ?>"><?php esc_attr_e('Advanced', 'dagt'); ?></a>
                </div>

                <form method='post' action='options.php' autocomplete="off">

                    <?php

                    if( $active_tab == 'typography_options' ) {

                            settings_fields( $this->shared->get('slug') . '_typography_options' );
                            do_settings_sections( $this->shared->get('slug') . '_typography_options' );

                    }
                    
                    if( $active_tab == 'colors_options' ) {

                            settings_fields( $this->shared->get('slug') . '_colors_options' );
                            do_settings_sections( $this->shared->get('slug') . '_colors_options' );

                    }
                    
                    if( $active_tab == 'labels_options' ) {

                            settings_fields( $this->shared->get('slug') . '_labels_options' );
                            do_settings_sections( $this->shared->get('slug') . '_labels_options' );

                    }
                    
                    if( $active_tab == 'advanced_options' ) {

                        settings_fields( $this->shared->get('slug') . '_advanced_options' );
                        do_settings_sections( $this->shared->get('slug') . '_advanced_options' );

                    }

                    ?>

                    <div class="daext-options-action">
                        <input type="submit" name="submit" id="submit" class="button" value="<?php esc_attr_e('Save Changes', 'dagt'); ?>">
                    </div>

                </form>

            </div>

        </div>