<?php

        if ( !current_user_can(get_option( $this->shared->get('slug') . "_sections_menu_capability")) )  {
                wp_die( esc_attr__( 'You do not have sufficient permissions to access this page.' ) );
        }

        ?>

        <!-- process data -->

        <?php
        
         if( isset( $_POST['update_id'] ) or isset($_POST['form_submitted']) ){
             
            extract($_POST);
             
            $invalid_data_message = '';
             
            //validation on "title"
            if( mb_strlen( trim($title) ) == 0 or mb_strlen(stripslashes($title)) > 255 ){
                $invalid_data_message .= '<div class="error settings-error notice is-dismissible below-h2"><p>' . esc_attr__('Please enter a valid value in the "Title" field.', 'dagt') . '</p></div>';
                $invalid_data = true;
            }
            
            //validation on "description"
            if( mb_strlen( trim($description) ) == 0 or mb_strlen(stripslashes($description)) > 1000 ){
                $invalid_data_message .= '<div class="error settings-error notice is-dismissible below-h2"><p>' . esc_attr__('Please enter a valid value in the "Description" field.', 'dagt') . '</p></div>';
                $invalid_data = true;
            }
            
            //validation on the sentences
            if( strlen(trim($sentence1)) == 0 and
                strlen(trim($sentence2)) == 0 and
                strlen(trim($sentence3)) == 0 and
                strlen(trim($sentence4)) == 0 and
                strlen(trim($sentence5)) == 0 and
                strlen(trim($sentence6)) == 0 and
                strlen(trim($sentence7)) == 0 and
                strlen(trim($sentence8)) == 0 and
                strlen(trim($sentence9)) == 0 and
                strlen(trim($sentence10)) == 0 ){
                $invalid_data_message .= '<div class="error settings-error notice is-dismissible below-h2"><p>' . esc_attr__('Please enter at least one sentence.', 'dagt') . '</p></div>';
                $invalid_data = true;
            }
            
            //verify the lenght of the sentences
            if( mb_strlen(trim(stripslashes($sentence1))) > 1000 or
                mb_strlen(trim(stripslashes($sentence2))) > 1000 or
                mb_strlen(trim(stripslashes($sentence3))) > 1000 or
                mb_strlen(trim(stripslashes($sentence4))) > 1000 or
                mb_strlen(trim(stripslashes($sentence5))) > 1000 or
                mb_strlen(trim(stripslashes($sentence6))) > 1000 or
                mb_strlen(trim(stripslashes($sentence7))) > 1000 or
                mb_strlen(trim(stripslashes($sentence8))) > 1000 or
                mb_strlen(trim(stripslashes($sentence9))) > 1000 or
                mb_strlen(trim(stripslashes($sentence10))) > 1000 ){
                $invalid_data_message .= '<div class="error settings-error notice is-dismissible below-h2"><p>' . esc_attr__("You can't enter more than 1000 characters in a sentence.", 'dagt') . '</p></div>';
                $invalid_data = true;
            }
            
            /*
             * Verify that:
             * 
             * 1 - All the "mw" and "ms" included in the sentences
             * 2 - There are no sentences that don't include "ms" or "mw"
             * 
             * These conditions are verified only on the non-empty sentences
             */
            for($i=1;$i<=10;$i++){
                if(strlen(trim(${"sentence" . $i})) > 0){
                    if(!$this->shared->is_valid_sentence(stripslashes(${"sentence" . $i}))){
                        $invalid_data_message .= '<div class="error settings-error notice is-dismissible below-h2"><p>' . esc_attr__("Sentence", 'dagt') . ' ' . $i . ' ' . esc_attr__("is not valid, you have entered invalid missing words, invalid multiple selections or not entered missing words and multiple selections.", 'dagt') . '</p></div>';
                        $invalid_data = true;
                    }
                }
            }
            
        }
        
        //update ---------------------------------------------------------------
        if( isset( $_POST['update_id'] ) and !isset($invalid_data) ){
            
            /*
             * Prevent the creation of empty sentences followed by non-empty
             * sentences by moving all the sentences to the first positions
             */
            $sentences_a = $this->shared->prepare_sentences(
                trim($sentence1),
                trim($sentence2),
                trim($sentence3),
                trim($sentence4),
                trim($sentence5),
                trim($sentence6),
                trim($sentence7),
                trim($sentence8),
                trim($sentence9),
                trim($sentence10)
            );
            
            //update the database
            global $wpdb;
            $table_name = $wpdb->prefix . $this->shared->get('slug') . "_section";
            $safe_sql = $wpdb->prepare("UPDATE $table_name SET 
                title = %s,
                description = %s,
                sentence1 = %s,
                sentence2 = %s,
                sentence3 = %s,
                sentence4 = %s,
                sentence5 = %s,
                sentence6 = %s,
                sentence7 = %s,
                sentence8 = %s,
                sentence9 = %s,
                sentence10 = %s,
                enumerate = %d
                WHERE id = %d",
                $title,
                $description,
                $sentences_a[0],
                $sentences_a[1],
                $sentences_a[2],
                $sentences_a[3],
                $sentences_a[4],
                $sentences_a[5],
                $sentences_a[6],
                $sentences_a[7],
                $sentences_a[8],
                $sentences_a[9],
                $enumerate,
                $update_id);

            $query_result = $wpdb->query( $safe_sql );

            if($query_result !== false){
                $process_data_message = '<div class="updated settings-error notice is-dismissible below-h2"><p>' . esc_attr__('The section has been successfully updated.', 'dagt') . '</p></div>';
            }
            
        }else{
            
            //add ------------------------------------------------------------------
            if( isset($_POST['form_submitted']) and !isset($invalid_data) ){

                /*
                 * Prevent the creation of empty sentences followed by non-empty
                 * sentences by moving all the sentences to the first positions
                 */
                $sentences_a = $this->shared->prepare_sentences(
                    trim($sentence1),
                    trim($sentence2),
                    trim($sentence3),
                    trim($sentence4),
                    trim($sentence5),
                    trim($sentence6),
                    trim($sentence7),
                    trim($sentence8),
                    trim($sentence9),
                    trim($sentence10)
                );
                
                //insert into the database
                global $wpdb;
                $table_name = $wpdb->prefix . $this->shared->get('slug') . "_section";
                $safe_sql = $wpdb->prepare("INSERT INTO $table_name SET 
                    title = %s,
                    description = %s,
                    sentence1 = %s,
                    sentence2 = %s,
                    sentence3 = %s,
                    sentence4 = %s,
                    sentence5 = %s,
                    sentence6 = %s,
                    sentence7 = %s,
                    sentence8 = %s,
                    sentence9 = %s,
                    sentence10 = %s,
                    enumerate = %d",
                    $title,
                    $description,
                    $sentences_a[0],
                    $sentences_a[1],
                    $sentences_a[2],
                    $sentences_a[3],
                    $sentences_a[4],
                    $sentences_a[5],
                    $sentences_a[6],
                    $sentences_a[7],
                    $sentences_a[8],
                    $sentences_a[9],
                    $enumerate
                    );

                $query_result = $wpdb->query( $safe_sql );

                if($query_result !== false){
                    $process_data_message = '<div class="updated settings-error notice is-dismissible below-h2"><p>' . esc_attr__('The section has been successfully added.', 'dagt') . '</p></div>';
                }

            }
            
        }
        
        //delete a test
        if( isset( $_POST['delete_id']) ){

            global $wpdb;
            $delete_id = intval($_POST['delete_id'], 10);
            
            //prevent the cancellation of a section used in a test
            if($this->shared->is_section_used($delete_id)){
                
                //do not delete the section and generate a proper message
                $process_data_message = '<div class="error settings-error notice is-dismissible below-h2"><p>' . esc_attr__("This section can't be deleted because it's used in a test.", 'dagt') . '</p></div>';
                
            }else{
                
                //delete the section
                $table_name = $wpdb->prefix . $this->shared->get('slug') . "_section";
                $safe_sql = $wpdb->prepare("DELETE FROM $table_name WHERE id = %d ", $delete_id);

                $query_result = $wpdb->query( $safe_sql ); 

                if($query_result !== false){
                    $process_data_message = '<div class="updated settings-error notice is-dismissible below-h2"><p>' . esc_attr__('The section has been successfully deleted.', 'dagt') . '</p></div>';
                }
                
            }
            
        }
        
        //clone the section
        if( isset( $_POST['clone_id']) ){

            global $wpdb;
            $clone_id = intval($_POST['clone_id'], 10);

            //clone the section
            $table_name = $wpdb->prefix . $this->shared->get('slug') . "_section";
            $wpdb->query("CREATE TEMPORARY TABLE tmptable_1 SELECT * FROM $table_name WHERE id = $clone_id");
            $wpdb->query("UPDATE tmptable_1 SET id = NULL");
            $wpdb->query("INSERT INTO $table_name SELECT * FROM tmptable_1");
            $wpdb->query("DROP TEMPORARY TABLE IF EXISTS tmptable_1");

        } 
        
        //get the test data
        if(isset($_GET['edit_id'])){
            $edit_id = intval($_GET['edit_id'], 10);
            global $wpdb;
            $table_name = $wpdb->prefix . $this->shared->get('slug') . "_section";
            $safe_sql = $wpdb->prepare("SELECT * FROM $table_name WHERE id = %d ", $edit_id);
            $section_obj = $wpdb->get_row($safe_sql); 
        }
        
        ?>
        
        <!-- output -->

        <div class="wrap">

        <?php if ($this->shared->number_of_sections() > 0) : ?>

            <div id="daext-header-wrapper" class="daext-clearfix">

                <h2><?php esc_attr_e('Grammar Test - Sections', 'dagt'); ?></h2>

                <form action="admin.php" method="get">
                    <input type="hidden" name="page" value="dagt-sections">
                    <?php
                    if (isset($_GET['s']) and strlen(trim($_GET['s'])) > 0) {
                        $search_string = $_GET['s'];
                    } else {
                        $search_string = '';
                    }
                    ?>
                    <input type="text" name="s" placeholder="<?php esc_attr_e('Search...', 'dagt'); ?>"
                           value="<?php echo esc_attr(stripslashes($search_string)); ?>" autocomplete="off" maxlength="255">
                    <input type="submit" value="">
                </form>

            </div>

        <?php else: ?>

            <div id="daext-header-wrapper" class="daext-clearfix">

                <h2><?php esc_attr_e('Grammar Test - Sections', 'dagt'); ?></h2>

            </div>

        <?php endif; ?>

        <div id="daext-menu-wrapper">

            <?php if(isset($invalid_data_message)){echo $invalid_data_message;} ?>
            <?php if(isset($process_data_message)){echo $process_data_message;} ?>
            
            <!-- table -->

            <?php

            //create the query part used to filter the results when a search is performed
            if (isset($_GET['s']) and strlen(trim($_GET['s'])) > 0) {
                $search_string = $_GET['s'];
                global $wpdb;
                $filter = $wpdb->prepare('WHERE (id LIKE %s OR title LIKE %s OR description LIKE %s)', '%' . $search_string . '%', '%' . $search_string . '%','%' . $search_string . '%');
            } else {
                $filter = '';
            }

            //retrieve the total number of tests
            global $wpdb;
            $table_name=$wpdb->prefix . $this->shared->get('slug') . "_section";
            $total_items = $wpdb->get_var( "SELECT COUNT(*) FROM $table_name $filter");

            //Initialize the pagination class
            require_once( $this->shared->get('dir') . '/admin/inc/class-dagt-pagination.php' );
            $pag = new dagt_pagination();
            $pag->set_total_items( $total_items );//Set the total number of items
            $pag->set_record_per_page( 10 ); //Set records per page
            $pag->set_target_page( "admin.php?page=" . $this->shared->get('slug') . "-sections" );//Set target page
            $pag->set_current_page();//set the current page number from $_GET

            ?>

            <!-- Query the database -->
            <?php
            $query_limit = $pag->query_limit();
            $results = $wpdb->get_results("SELECT * FROM $table_name $filter ORDER BY id DESC $query_limit ", ARRAY_A); ?>

            <?php if( count($results) > 0 ) : ?>

            <div class="daext-items-container">

                <!-- list of tables -->
                <table class="daext-items">
                    <thead>
                        <tr>
                            <th>
                                <div><?php esc_attr_e('Title', 'dagt'); ?></div>
                                <div class="help-icon" title="<?php esc_attr_e('The title of the section.', 'dagt'); ?>"></div>
                            </th>
                            <th></th>
                        </tr>
                    </thead>
                    <tbody>

                    <?php foreach($results as $result) : ?>
                        <tr>
                            <td><?php echo esc_attr(stripslashes($result['title'])); ?></td>
                            <td class="icons-container">
                                <form method="POST" action="admin.php?page=dagt-sections">
                                    <input type="hidden" name="clone_id" value="<?php echo $result['id']; ?>">
                                    <input class="menu-icon clone help-icon" name="clone_test" class="button" type="submit" value="" title="<?php esc_attr_e('Clone the section', 'dagt'); ?>">
                                </form>
                                <a class="menu-icon edit" href="admin.php?page=<?php echo $this->shared->get('slug'); ?>-sections&edit_id=<?php echo $result['id']; ?>" title="<?php esc_attr_e('Edit the section', 'dagt'); ?>"></a>
                                <form method="POST" action="admin.php?page=<?php echo $this->shared->get('slug'); ?>-sections">
                                    <input type="hidden" value="<?php echo $result['id']; ?>" name="delete_id" >
                                    <input class="menu-icon delete" type="submit" value="" title="<?php esc_attr_e('Delete the section', 'dagt'); ?>">
                                </form>
                            </td>
                        </tr>
                    <?php endforeach; ?>

                    </tbody>

                </table>

            </div>

                <!-- Display the pagination -->
                <?php if($pag->total_items > 0) : ?>
                    <div class="daext-tablenav daext-clearfix">
                        <div class="daext-tablenav-pages">
                            <span class="daext-displaying-num"><?php echo $pag->total_items; ?> <?php esc_attr_e('items', 'dagt'); ?></span>
                            <?php $pag->show(); ?>
                        </div>
                    </div>
                <?php endif; ?>

            <?php endif; ?>

             <form method="POST" action="admin.php?page=<?php echo $this->shared->get('slug'); ?>-sections" >

                <input type="hidden" value="1" name="form_submitted">
                 
                <?php if(isset($_GET['edit_id'])) : ?>

                    <!-- Edit a Section -->

                    <div class="daext-form-container">

                        <h3 class="daext-form-title"><?php esc_attr_e('Edit Section', 'dagt'); ?> <?php echo $section_obj->id; ?></h3>

                        <table class="daext-form">

                            <input type="hidden" name="update_id" value="<?php echo $section_obj->id; ?>" />

                             <!-- Title -->
                             <tr valign="top">
                                 <th scope="row"><label for="title"><?php esc_attr_e('Title', 'dagt'); ?></label></th>
                                 <td>
                                     <input value="<?php echo esc_attr(stripslashes($section_obj->title)); ?>" type="text" id="title" maxlength="255" size="30" name="title" autocomplete="off" />
                                     <div class="help-icon" title="<?php esc_attr_e('The title of the section.', 'dagt'); ?>"></div>
                                 </td>
                             </tr>
                             
                             <!-- Description -->
                             <tr valign="top">
                                 <th scope="row"><label for="title"><?php esc_attr_e('Description', 'dagt'); ?></label></th>
                                 <td>
                                     <input value="<?php echo esc_attr(stripslashes($section_obj->description)); ?>" type="text" id="description" maxlength="1000" size="30" name="description" autocomplete="off" />
                                     <div class="help-icon" title="<?php esc_attr_e('The description of the section.', 'dagt'); ?>"></div>
                                 </td>
                             </tr>
                             
                            <!-- Sentence 1 to 10 -->
                            <?php

                            for($i=1;$i<=10;$i++){

                                ?>

                                <tr valign="top">
                                    <th scope="row"><label for="title"><?php esc_attr_e('Sentence', 'dagt'); ?> <?php echo $i; ?></label></th>
                                    <td class="dagt-sentence-container" id="dagt-sentence-container-<?php echo $i; ?>">
                                        
                                        <?php
                                        
                                        $data_mw_edit_enabled = $this->shared->enable_missing_word_edit(stripslashes($section_obj->{"sentence" . $i}));
                                        $data_ms_edit_enabled = $this->shared->enable_multiple_selection_edit(stripslashes($section_obj->{"sentence" . $i}));
                                        
                                        ?>
                                        
                                        <input data-mw-edit-enabled="<?php echo intval($data_mw_edit_enabled, 10); ?>"  data-ms-edit-enabled="<?php echo intval($data_ms_edit_enabled, 10); ?>" class="dagt-sentence" value="<?php echo esc_attr(stripslashes($section_obj->{"sentence" . $i})); ?>" type="text" id="sentence<?php echo $i; ?>" maxlength="1000" size="30" name="sentence<?php echo $i; ?>" autocomplete="off" />
                                        <div class="dagp-nmw-modal-window" data-id="<?php echo $i; ?>" title="<?php esc_attr_e('Add Missing Word', 'dagt'); ?>"></div>
                                        
                                        <?php if(!$data_mw_edit_enabled) : ?>
                                            <!-- Edit Disabled -->
                                            <div class="dagp-emw-modal-window dagt-emw-greyed" data-id="<?php echo $i; ?>" title="<?php esc_attr_e('Edit Missing Word', 'dagt'); ?>"></div>
                                        <?php else : ?>
                                            <!-- Edit Enabled -->
                                            <div data-mw-edit-enabled="1" class="dagp-emw-modal-window" data-id="<?php echo $i; ?>" title="<?php esc_attr_e('Edit Missing Word', 'dagt'); ?>"></div>
                                        <?php endif; ?>
                                            
                                        <div class="dagp-nms-modal-window" data-id="<?php echo $i; ?>" title="<?php esc_attr_e('Add Multiple Selection', 'dagt'); ?>"></div>
                                        
                                        <?php if(!$data_ms_edit_enabled) : ?>
                                        <!-- Edit Disabled -->
                                            <div class="dagp-ems-modal-window dagt-ems-greyed" data-id="<?php echo $i; ?>" title="<?php esc_attr_e('Edit Multiple Selection', 'dagt'); ?>"></div>
                                        <?php else : ?>   
                                            <!-- Edit Enabled -->
                                            <div data-ms-edit-enabled="1" class="dagp-ems-modal-window" data-id="<?php echo $i; ?>" title="<?php esc_attr_e('Edit Multiple Selection', 'dagt'); ?>"></div>
                                        <?php endif; ?>

                                        <div class="help-icon" title="<?php esc_attr_e('A sentence with included missing words or multiple selections.', 'dagt'); ?>"></div>
                                    </td>
                                </tr>

                                <?php

                           }

                           ?>
                                
                            <!-- Enumerate -->
                            <tr>
                                <th scope="row"><?php esc_attr_e('Enumerate', 'dagt'); ?></th>
                                <td>
                                    <select class="daext-visibility-hidden" name="enumerate" id="dagt-enumerate">
                                        <option value="1" <?php selected($section_obj->enumerate, 1); ?>><?php esc_attr_e('Yes', 'dagt'); ?></option>
                                        <option value="0" <?php selected($section_obj->enumerate, 0); ?>><?php esc_attr_e('No', 'dagt'); ?></option>
                                    </select>
                                    <div class="help-icon" title="<?php esc_attr_e('Select "Yes" to enumerate the sentences.', 'dagt'); ?>"></div>
                                </td>
                            </tr>
                            
                        </table>
                        
                        <!-- submit button -->
                        <div class="daext-form-action">
                            <input class="button" type="submit" value="<?php esc_attr_e('Update Section', 'dagt'); ?>" >
                            <input id="cancel" class="button" type="submit" value="<?php esc_attr_e('Cancel', 'dagt'); ?>">
                        </div>

                <?php else : ?>

                    <!-- Create New Section -->

                    <div class="daext-form-container">

                        <div class="daext-form-title"><?php esc_attr_e('Create New Section', 'dagt'); ?></div>

                             <table class="daext-form">

                             <!-- Title -->
                             <tr valign="top">
                                 <th scope="row"><label for="title"><?php esc_attr_e('Title', 'dagt'); ?></label></th>
                                 <td>
                                     <input type="text" id="title" maxlength="255" size="30" name="title" autocomplete="off" />
                                     <div class="help-icon" title="<?php esc_attr_e('The title of the section.', 'dagt'); ?>"></div>
                                 </td>
                             </tr>
                             
                             <!-- Description -->
                             <tr valign="top">
                                 <th scope="row"><label for="title"><?php esc_attr_e('Description', 'dagt'); ?></label></th>
                                 <td>
                                     <input type="text" id="description" maxlength="1000" size="30" name="description" autocomplete="off" />
                                     <div class="help-icon" title="<?php esc_attr_e('The description of the section.', 'dagt'); ?>"></div>
                                 </td>
                             </tr>
                             
                            <!-- Sentence 1 to 10 -->
                            <?php

                            for($i=1;$i<=10;$i++){

                                ?>

                                <tr valign="top">
                                    <th scope="row"><label for="title"><?php esc_attr_e('Sentence', 'dagt'); ?> <?php echo $i; ?></label></th>
                                    <td class="dagt-sentence-container" id="dagt-sentence-container-<?php echo $i; ?>">
                                        <input data-mw-edit-enabled="0"  data-ms-edit-enabled="0" type="text" maxlength="1000" class="dagt-sentence" id="sentence<?php echo $i; ?>" name="sentence<?php echo $i; ?>" autocomplete="off" />
                                        <div class="dagp-nmw-modal-window" data-id="<?php echo $i; ?>" title="<?php esc_attr_e('Add Missing Word', 'dagt'); ?>"></div>
                                        <div class="dagp-emw-modal-window dagt-emw-greyed" data-id="<?php echo $i; ?>" title="<?php esc_attr_e('Edit Missing Word', 'dagt'); ?>"></div>
                                        <div class="dagp-nms-modal-window" data-id="<?php echo $i; ?>" title="<?php esc_attr_e('Add Multiple Selection', 'dagt'); ?>"></div>
                                        <div class="dagp-ems-modal-window dagt-ems-greyed" data-id="<?php echo $i; ?>" title="<?php esc_attr_e('Edit Multiple Selection', 'dagt'); ?>"></div>
                                        <div class="help-icon" title="<?php esc_attr_e('A sentence with included missing words or multiple selections.', 'dagt'); ?>"></div>
                                    </td>
                                </tr>

                                <?php

                           }

                           ?>

                            <!-- Enumerate -->
                            <tr>
                                <th scope="row"><?php esc_attr_e('Enumerate', 'dagt'); ?></th>
                                <td>
                                    <select class="daext-visibility-hidden" name="enumerate" id="dagt-enumerate">
                                        <option value="1" ><?php esc_attr_e('Yes', 'dagt'); ?></option>
                                        <option value="0" ><?php esc_attr_e('No', 'dagt'); ?></option>
                                    </select>
                                    <div class="help-icon" title="<?php esc_attr_e('Select "Yes" to enumerate the sentences.', 'dagt'); ?>"></div>
                                </td>
                            </tr>  
                                
                            </table>
                        
                            <!-- submit button -->
                            <div class="daext-form-action">
                                <input class="button" type="submit" value="<?php esc_attr_e('Add Section', 'dagt'); ?>" >
                            </div>

                        <?php endif; ?>

                    </div>

            </form>

        </div>

    </div>