<?php

        if ( !current_user_can(get_option( $this->shared->get('slug') . "_students_menu_capability")) )  {
                wp_die( esc_attr__( 'You do not have sufficient permissions to access this page.' ) );
        }

        ?>

        <!-- output -->

        <div class="wrap">

            <?php if ($this->shared->get_number_of_students() > 0) : ?>

                <div id="daext-header-wrapper" class="daext-clearfix">

                    <h2>Grammar Test - <?php esc_attr_e('Students', 'dagt'); ?></h2>

                    <form action="admin.php" method="get">
                        <input type="hidden" name="page" value="dagt-students">
                        <?php
                        if (isset($_GET['s']) and strlen(trim($_GET['s'])) > 0) {
                            $search_string = $_GET['s'];
                        } else {
                            $search_string = '';
                        }
                        ?>
                        <input type="text" name="s" placeholder="<?php esc_attr_e('Search...', 'dagt'); ?>"
                               value="<?php echo esc_attr(stripslashes($search_string)); ?>" autocomplete="off" maxlength="255">
                        <input type="submit" value="">
                    </form>

                </div>

            <?php else: ?>

                <div id="daext-header-wrapper" class="daext-clearfix">

                    <h2>Grammar Test - <?php esc_attr_e('Students', 'dagt'); ?></h2>

                </div>

            <?php endif; ?>

            <div id="daext-menu-wrapper">

                <!-- table -->

                <?php

                global $wpdb;

                //create the query part used to filter the results when a search is performed
                if (isset($_GET['s']) and strlen(trim($_GET['s'])) > 0) {
                    $search_string = $_GET['s'];
                    global $wpdb;
                    $filter = $wpdb->prepare('WHERE (ID LIKE %s OR user_login LIKE %s OR user_nicename LIKE %s OR display_name LIKE %s)', '%' . $search_string . '%', '%' . $search_string . '%', '%' . $search_string . '%','%' . $search_string . '%');
                } else {
                    $filter = '';
                }

                //get all the players
                $results = $wpdb->get_results("SELECT * FROM $wpdb->users $filter ORDER BY id DESC", ARRAY_A);

                //create an array with the IDs of the players
                foreach($results as $result){
                    /*
                     * Here !user_can($result['ID'], 'manage_options') is used because with WordPress Multisite
                     * user_can() always returns true if the current user is the network administrator.
                     *
                     * If only user_can($result['ID'], 'dagt_perform_practice_and_examination') is used the multisite
                     * administrator is displayed in the list of students.
                     */
	                if( !user_can($result['ID'], 'manage_options') and user_can($result['ID'], 'dagt_perform_practice_and_examination') ){
                        //add this user to the array of players
                        $ID_of_players[] = $result['ID'];
                    }
                }

                //get the total number of players
                if(isset($ID_of_players)){
                    $total_items = count($ID_of_players);
                }else{
                    $total_items = 0;
                }

                if($total_items > 0){
                    
                    //Initialize the pagination class
                    require_once( $this->shared->get('dir') . '/admin/inc/class-dagt-pagination.php' );
                    $pag = new dagt_pagination();
                    $pag->set_total_items( $total_items );//Set the total number of items
                    $pag->set_record_per_page( 10 ); //Set records per page
                    $pag->set_target_page( "admin.php?page=" . $this->shared->get('slug') . "-students" );//Set target page
                    $pag->set_current_page();//set the current page number from $_GET

                    ?>

                    <!-- Query the database -->
                    <?php
                    $query_limit = $pag->query_limit();
                    $list_of_id = implode(',', $ID_of_players);
                    $results = $wpdb->get_results("SELECT * FROM $wpdb->users WHERE ID in ($list_of_id) ORDER BY id DESC $query_limit", ARRAY_A); ?>

                    <div class="daext-items-container">

                        <!-- list of tables -->
                        <table class="daext-items">
                            <thead>
                                <tr>
                                    <th>
                                        <div><?php esc_attr_e('Name', 'dagt'); ?></div>
                                        <div class="help-icon" title="<?php esc_attr_e('The name of the student.', 'dagt'); ?>"></div>
                                    </th>
                                    <th>
                                        <div><?php esc_attr_e('Correct Answers', 'dagt'); ?></div>
                                        <div class="help-icon" title="<?php esc_attr_e('The number of correct answers submitted by the student.', 'dagt'); ?>"></div>
                                    </th>
                                    <th>
                                        <div><?php esc_attr_e('Wrong Answers', 'dagt'); ?></div>
                                        <div class="help-icon" title="<?php esc_attr_e('The number of wrong answers submitted by the student.', 'dagt'); ?>"></div>
                                    </th>
                                    <th>
                                        <div><?php esc_attr_e('Score', 'dagt'); ?></div>
                                        <div class="help-icon" title="<?php esc_attr_e('The score of the student.', 'dagt'); ?>"></div>
                                    </th>
                                    <th></th>
                                </tr>
                            </thead>
                            <tbody>

                            <?php foreach($results as $result) : ?>

                                <?php
                                
                                $correct_answers_of_student = $this->get_correct_answers_of_student($result['ID']);
                                $total_answers_of_student = $this->get_total_answers_of_student($result['ID']);
                                $wrong_answers_of_student = $total_answers_of_student - $correct_answers_of_student;
                                if($total_answers_of_student > 0){
                                    $score_percentage = intval( $correct_answers_of_student / $total_answers_of_student * 100, 10 );
                                }else{
                                    $score_percentage = 0;
                                }
                                
                                ?>
                                
                                <tr>
                                    <td><?php echo esc_attr(stripslashes($result['display_name'])); ?></td>
                                    <td><?php echo $correct_answers_of_student; ?></td>
                                    <td><?php echo $wrong_answers_of_student; ?></td>
                                    <td><?php echo $score_percentage . '%'; ?></td>
                                    <td class="icons-container">
                                        <form method="POST" action="admin.php?page=dagt-students">
                                            <input type="hidden" name="user_id" value="<?php echo $result['ID']; ?>">
                                            <input class="menu-icon download help-icon <?php if($this->shared->no_student_results($result['ID'])){echo 'download-greyed';} ?>" name="export_csv" class="button" type="submit" value="" title="<?php esc_attr_e('Download a CSV file that includes the results of this student.', 'dagt'); ?>">
                                        </form>
                                    </td>
                                </tr>

                            <?php endforeach; ?>

                            </tbody>

                        </table>

                    </div>

                    <!-- Display the pagination -->
                    <div class="daext-tablenav daext-clearfix">
                        <div class="daext-tablenav-pages">
                            <span class="daext-displaying-num"><?php echo $pag->total_items; ?> <?php esc_attr_e('items', 'dagt'); ?></span>
                            <?php $pag->show(); ?>
                        </div>
                    </div>
                    
                    <?php
                    
                }else{

                    if(!isset($_GET['s'])){
                        echo '<p>' . esc_attr__('There are no subscribed students', 'dagt') . '.</p>';
                    }else{
                        echo '<p>' . esc_attr__('There are no results that meet your search criteria', 'dagt') . '.</p>';
                    }

                }
                
                ?>
                
            </div>

    </div>