<?php

        if ( !current_user_can(get_option( $this->shared->get('slug') . "_tests_menu_capability")) )  {
                wp_die( esc_attr__( 'You do not have sufficient permissions to access this page.' ) );
        }

        ?>

        <!-- process data -->

        <?php

         if( isset( $_POST['update_id'] ) or isset($_POST['form_submitted']) ){

            extract($_POST);

            $invalid_data_message = '';

            //validation on "title"
            if( mb_strlen( trim($title) ) == 0 or mb_strlen(stripslashes($title)) > 255 ){
                $invalid_data_message .= '<div class="error settings-error notice is-dismissible below-h2"><p>' . esc_attr__('Please enter a valid value in the "Title" field.', 'dagt') . '</p></div>';
                $invalid_data = true;
            }

            //validation on "description"
            if( mb_strlen( trim($description) ) == 0 or mb_strlen(stripslashes($description)) > 1000 ){
                $invalid_data_message .= '<div class="error settings-error notice is-dismissible below-h2"><p>' . esc_attr__('Please enter a valid value in the "Description" field.', 'dagt') . '</p></div>';
                $invalid_data = true;
            }

            //validation on the sections
            if( intval($section1_id, 10) == 0 and
                intval($section2_id, 10) == 0 and
                intval($section3_id, 10) == 0 and
                intval($section4_id, 10) == 0 and
                intval($section5_id, 10) == 0 and
                intval($section6_id, 10) == 0 and
                intval($section7_id, 10) == 0 and
                intval($section8_id, 10) == 0 and
                intval($section9_id, 10) == 0 and
                intval($section10_id, 10) == 0 ){
                $invalid_data_message .= '<div class="error settings-error notice is-dismissible below-h2"><p>' . esc_attr__('Please select at least one section.', 'dagt') . '</p></div>';
                $invalid_data = true;
            }

            //verify that the same section has not been selected multiple times
            $section_id_a = array();
            for($i=1;$i<=10;$i++){
                if( intval( ${"section" . $i . "_id"}, 10) > 0 ){
                    $section_id_a[] = intval( ${"section" . $i . "_id"}, 10);
                }
            }
            if( count($section_id_a) != count(array_unique($section_id_a)) ){
                $invalid_data_message .= '<div class="error settings-error notice is-dismissible below-h2"><p>' . esc_attr__("You can't use the same section multiple times in a single test.", 'dagt') . '</p></div>';
                $invalid_data = true;
            }

            //verify that the sections with identifier different than 0 exist
            for($i=1;$i<=10;$i++){

                $parse_section_id = ${"section" . $i . "_id"};
                if( $parse_section_id != 0 and !$this->shared->section_exists($parse_section_id)){
                    $invalid_data_message .= '<div class="error settings-error notice is-dismissible below-h2"><p>' . esc_attr__("One or more selected sections don't exist.", 'dagt') . '</p></div>';
                    $invalid_data = true;
                }

            }

            //validation on "additional info"
            if( mb_strlen(stripslashes($additional_info)) > 1000 ){
                $invalid_data_message .= '<div class="error settings-error notice is-dismissible below-h2"><p>' . esc_attr__('Please enter a valid value in the "Additional Info" field.', 'dagt') . '</p></div>';
                $invalid_data = true;
            }

        }

        //update ---------------------------------------------------------------
        if( isset( $_POST['update_id'] ) and !isset($invalid_data) ){

            /*
             * Prevent the creation of empty sections followed by selected
             * sections and move all the sections to the first positions
             */
            $sections_a = $this->shared->prepare_sections(
                $section1_id,
                $section2_id,
                $section3_id,
                $section4_id,
                $section5_id,
                $section6_id,
                $section7_id,
                $section8_id,
                $section9_id,
                $section10_id
            );

            //update the database
            global $wpdb;
            $table_name = $wpdb->prefix . $this->shared->get('slug') . "_test";
            $safe_sql = $wpdb->prepare("UPDATE $table_name SET 
                title = %s,
                description = %s,
                section1_id = %d,
                section2_id = %d,
                section3_id = %d,
                section4_id = %d,
                section5_id = %d,
                section6_id = %d,
                section7_id = %d,
                section8_id = %d,
                section9_id = %d,
                section10_id = %d,
                additional_info = %s,
                type = %d
                WHERE id = %d",
                $title,
                $description,
                $sections_a[0],
                $sections_a[1],
                $sections_a[2],
                $sections_a[3],
                $sections_a[4],
                $sections_a[5],
                $sections_a[6],
                $sections_a[7],
                $sections_a[8],
                $sections_a[9],
                $additional_info,
                $type,
                $update_id);

            $query_result = $wpdb->query( $safe_sql );

            if($query_result !== false){
                $process_data_message = '<div class="updated settings-error notice is-dismissible below-h2"><p>' . esc_attr__('The test has been successfully updated.', 'dagt') . '</p></div>';
            }

        }else{

            //add ------------------------------------------------------------------
            if( isset($_POST['form_submitted']) and !isset($invalid_data) ){

                /*
                 * Prevent the creation of empty sections followed by selected
                 * sections and move all the sections to the first positions
                 */
                $sections_a = $this->shared->prepare_sections(
                    $section1_id,
                    $section2_id,
                    $section3_id,
                    $section4_id,
                    $section5_id,
                    $section6_id,
                    $section7_id,
                    $section8_id,
                    $section9_id,
                    $section10_id
                );

                //insert into the database
                global $wpdb;
                $table_name = $wpdb->prefix . $this->shared->get('slug') . "_test";
                $safe_sql = $wpdb->prepare("INSERT INTO $table_name SET 
                    title = %s,
                    description = %s,
                    section1_id = %d,
                    section2_id = %d,
                    section3_id = %d,
                    section4_id = %d,
                    section5_id = %d,
                    section6_id = %d,
                    section7_id = %d,
                    section8_id = %d,
                    section9_id = %d,
                    section10_id = %d,
                    additional_info = %s,
                    type = %d",
                    $title,
                    $description,
                    $sections_a[0],
                    $sections_a[1],
                    $sections_a[2],
                    $sections_a[3],
                    $sections_a[4],
                    $sections_a[5],
                    $sections_a[6],
                    $sections_a[7],
                    $sections_a[8],
                    $sections_a[9],
                    $additional_info,
                    $type
                    );

                $query_result = $wpdb->query( $safe_sql );

                if($query_result !== false){
                    $process_data_message = '<div class="updated settings-error notice is-dismissible below-h2"><p>' . esc_attr__('The test has been successfully added.', 'dagt') . '</p></div>';
                }

            }

        }

        //delete a test
        if( isset( $_POST['delete_id']) ){

            global $wpdb;
            $delete_id = intval($_POST['delete_id'], 10);

            //delete this test
            $table_name = $wpdb->prefix . $this->shared->get('slug') . "_test";
            $safe_sql = $wpdb->prepare("DELETE FROM $table_name WHERE id = %d ", $delete_id);

            $query_result_1 = $wpdb->query( $safe_sql );

            //delete all the results associated with the test
            $table_name = $wpdb->prefix . $this->shared->get('slug') . "_result";
            $safe_sql = $wpdb->prepare("DELETE FROM $table_name WHERE test_id = %d ", $delete_id);

            $query_result_2 = $wpdb->query( $safe_sql );

            if($query_result_1 !== false){
                $process_data_message = '<div class="updated settings-error notice is-dismissible below-h2"><p>' . esc_attr__('The test has been successfully deleted.', 'dagt') . '</p></div>';
            }

        }

        //clone the test
        if( isset( $_POST['clone_id']) ){

            global $wpdb;
            $clone_id = intval($_POST['clone_id'], 10);

            //clone the test
            $table_name = $wpdb->prefix . $this->shared->get('slug') . "_test";
            $wpdb->query("CREATE TEMPORARY TABLE tmptable_1 SELECT * FROM $table_name WHERE id = $clone_id");
            $wpdb->query("UPDATE tmptable_1 SET id = NULL");
            $wpdb->query("INSERT INTO $table_name SELECT * FROM tmptable_1");
            $wpdb->query("DROP TEMPORARY TABLE IF EXISTS tmptable_1");

        }

        //get the test data
        if(isset($_GET['edit_id'])){
            $edit_id = intval($_GET['edit_id'], 10);
            global $wpdb;
            $table_name = $wpdb->prefix . $this->shared->get('slug') . "_test";
            $safe_sql = $wpdb->prepare("SELECT * FROM $table_name WHERE id = %d ", $edit_id);
            $test_obj = $wpdb->get_row($safe_sql);
        }

        ?>

        <!-- output -->

        <div class="wrap">

        <?php if ($this->shared->get_number_of_tests() > 0) : ?>

            <div id="daext-header-wrapper" class="daext-clearfix">

                <h2><?php esc_attr_e('Grammar Test - Tests', 'dagt'); ?></h2>

                <form action="admin.php" method="get">
                    <input type="hidden" name="page" value="dagt-tests">
                    <?php
                    if (isset($_GET['s']) and strlen(trim($_GET['s'])) > 0) {
                        $search_string = $_GET['s'];
                    } else {
                        $search_string = '';
                    }
                    ?>
                    <input type="text" name="s" placeholder="<?php esc_attr_e('Search...', 'dagt'); ?>"
                           value="<?php echo esc_attr(stripslashes($search_string)); ?>" autocomplete="off" maxlength="255">
                    <input type="submit" value="">
                </form>

            </div>

        <?php else: ?>

            <div id="daext-header-wrapper" class="daext-clearfix">

                <h2><?php esc_attr_e('Grammar Test - Tests', 'dagt'); ?></h2>

            </div>

        <?php endif; ?>

        <div id="daext-menu-wrapper">

            <?php if(isset($invalid_data_message)){echo $invalid_data_message;} ?>
            <?php if(isset($process_data_message)){echo $process_data_message;} ?>

            <!-- table -->

            <?php

            //create the query part used to filter the results when a search is performed
            if (isset($_GET['s']) and strlen(trim($_GET['s'])) > 0) {
                $search_string = $_GET['s'];
                global $wpdb;
                $filter = $wpdb->prepare('WHERE (id LIKE %s OR title LIKE %s OR description LIKE %s)', '%' . $search_string . '%', '%' . $search_string . '%','%' . $search_string . '%');
            } else {
                $filter = '';
            }

            //retrieve the total number of tests
            global $wpdb;
            $table_name=$wpdb->prefix . $this->shared->get('slug') . "_test";
            $total_items = $wpdb->get_var( "SELECT COUNT(*) FROM $table_name $filter");

            //Initialize the pagination class
            require_once( $this->shared->get('dir') . '/admin/inc/class-dagt-pagination.php' );
            $pag = new dagt_pagination();
            $pag->set_total_items( $total_items );//Set the total number of items
            $pag->set_record_per_page( 10 ); //Set records per page
            $pag->set_target_page( "admin.php?page=" . $this->shared->get('slug') . "-tests" );//Set target page
            $pag->set_current_page();//set the current page number from $_GET

            ?>

            <!-- Query the database -->
            <?php
            $query_limit = $pag->query_limit();
            $results = $wpdb->get_results("SELECT * FROM $table_name $filter ORDER BY id DESC $query_limit ", ARRAY_A); ?>

            <?php if( count($results) > 0 ) : ?>

            <div class="daext-items-container">

                <!-- list of tables -->
                <table class="daext-items">
                    <thead>
                        <tr>
                            <th>
                                <div><?php esc_attr_e('Title', 'dagt'); ?></div>
                                <div class="help-icon" title="<?php esc_attr_e('The title of the test.', 'dagt'); ?>"></div>
                            </th>
                            <th>
                                <div><?php esc_attr_e('Type', 'dagt'); ?></div>
                                <div class="help-icon" title="<?php esc_attr_e('The type of test.', 'dagt'); ?>"></div>
                            </th>
                            <th>
                                <div><?php esc_attr_e( 'Shortcode', 'dagt' ); ?></div>
                                <div class="help-icon" title="<?php esc_attr_e('The shortcode associated with the test.', 'dagt'); ?>"></div>
                            </th>
                            <th></th>
                        </tr>
                    </thead>
                    <tbody>

                    <?php foreach($results as $result) : ?>
                        <tr>
                            <td><?php echo esc_attr(stripslashes($result['title'])); ?></td>
                            <td>
                                <?php

                                switch($result['type']){

                                    case 1:
                                        esc_attr_e('Public Test', 'dagt');
                                        break;
                                    case 2:
                                        esc_attr_e('Free Practice', 'dagt');
                                        break;
                                    case 3:
                                        esc_attr_e('Practice', 'dagt');
                                        break;
                                    case 4:
                                        esc_attr_e('Examination', 'dagt');
                                        break;
                                }

                                ?>
                            </td>
                            <td><?php echo '[grammar-test id="' . intval($result['id'], 10) . '"]'; ?></td>
                            <td class="icons-container">
                                <form method="POST" action="admin.php?page=dagt-tests">
                                    <input type="hidden" name="test_id" value="<?php echo $result['id']; ?>">
                                    <input class="menu-icon download help-icon <?php if($this->shared->no_test_results($result['id'])){echo 'download-greyed';} ?>" name="export_csv" class="button" type="submit" value="" title="<?php esc_attr_e('Download a CSV file that includes the results of the test', 'dagt'); ?>">
                                </form>
                                <form method="POST" action="admin.php?page=dagt-tests">
                                    <input type="hidden" name="clone_id" value="<?php echo $result['id']; ?>">
                                    <input class="menu-icon clone help-icon" name="clone_test" class="button" type="submit" value="" title="<?php esc_attr_e('Clone the test', 'dagt'); ?>">
                                </form>
                                <a class="menu-icon edit" href="admin.php?page=<?php echo $this->shared->get('slug'); ?>-tests&edit_id=<?php echo $result['id']; ?>" title="<?php esc_attr_e('Edit the Test', 'dagt'); ?>"></a>
                                <form method="POST" action="admin.php?page=<?php echo $this->shared->get('slug'); ?>-tests">
                                    <input type="hidden" value="<?php echo $result['id']; ?>" name="delete_id">
                                    <input class="menu-icon delete" type="submit" value="" title="<?php esc_attr_e('Delete the Test', 'dagt'); ?>">
                                </form>
                            </td>
                        </tr>
                    <?php endforeach; ?>

                    </tbody>

                </table>

            </div>

                <!-- Display the pagination -->
                <?php if($pag->total_items > 0) : ?>
                    <div class="daext-tablenav daext-clearfix">
                        <div class="daext-tablenav-pages">
                            <span class="daext-displaying-num"><?php echo $pag->total_items; ?> <?php esc_attr_e('items', 'dagt'); ?></span>
                            <?php $pag->show(); ?>
                        </div>
                    </div>
                <?php endif; ?>

            <?php endif; ?>

             <form method="POST" action="admin.php?page=<?php echo $this->shared->get('slug'); ?>-tests" >

                <input type="hidden" value="1" name="form_submitted">

                <?php if(isset($_GET['edit_id'])) : ?>

                    <!-- Edit a Test -->

                    <div class="daext-form-container">

                        <h3 class="daext-form-title"><?php esc_attr_e('Edit Test', 'dagt'); ?> <?php echo $test_obj->id; ?></h3>

                        <table class="daext-form">

                            <input type="hidden" name="update_id" value="<?php echo $test_obj->id; ?>" />

                             <!-- Title -->
                             <tr valign="top">
                                 <th scope="row"><label for="keyword"><?php esc_attr_e('Title', 'dagt'); ?></label></th>
                                 <td>
                                     <input value="<?php echo esc_attr(stripslashes($test_obj->title)); ?>" type="text" id="title" maxlength="255" size="30" name="title" autocomplete="off" />
                                     <div class="help-icon" title="<?php esc_attr_e('The title of the test.', 'dagt'); ?>"></div>
                                 </td>
                             </tr>

                             <!-- Description -->
                             <tr valign="top">
                                 <th scope="row"><label for="keyword"><?php esc_attr_e('Description', 'dagt'); ?></label></th>
                                 <td>
                                     <input value="<?php echo esc_attr(stripslashes($test_obj->description)); ?>" type="text" id="description" maxlength="1000" size="30" name="description" autocomplete="off" />
                                     <div class="help-icon" title="<?php esc_attr_e('The description of the test.', 'dagt'); ?>"></div>
                                 </td>
                             </tr>

                            <!-- Section 1 to 10 -->
                            <?php

                            for($i=1;$i<=10;$i++){

                                ?>

                                <tr>
                                    <th scope="row"><?php esc_attr_e('Section', 'dagt'); ?> <?php echo $i; ?></th>
                                    <td>

                                         <select class="daext-visibility-hidden" id="section<?php echo $i; ?>_id" name="section<?php echo $i; ?>_id">

                                             <option value="0"><?php esc_attr_e('Empty', 'dagt'); ?></option>

                                             <?php

                                             global $wpdb;
                                             $table_name = $wpdb->prefix . $this->shared->get('slug') . "_section";
                                             $sql = "SELECT * FROM $table_name ORDER BY id DESC";
                                             $sections_a = $wpdb->get_results($sql, ARRAY_A);

                                             foreach ($sections_a as $key => $single_section) {
                                                 echo '<option value="' . $single_section['id'] .'" ' . selected($test_obj->{"section" . $i . "_id"}, $single_section['id']) . '>' . esc_attr(stripslashes($single_section['title'])) . '</option>';
                                             }

                                             ?>

                                         </select>
                                        <div class="help-icon" title="<?php esc_attr_e('The section of the test.', 'dagt'); ?>"></div>

                                    </td>
                                </tr>

                                <?php

                           }

                           ?>

                            <!-- Additional Info -->
                            <tr valign="top">
                                <th scope="row"><label for="additional_info"><?php esc_attr_e('Additional Information', 'dagt'); ?></label></th>
                                <td>
                                    <input value="<?php echo esc_attr(stripslashes($test_obj->additional_info)); ?>" type="text" id="additional_info" maxlength="255" size="30" name="additional_info" autocomplete="off" />
                                    <div class="help-icon" title="<?php esc_attr_e('Optional additional information displayed in the bottom section of the test.', 'dagt'); ?>"></div>
                                </td>
                            </tr>

                            <!-- Type -->
                            <tr>
                                <th scope="row"><?php esc_attr_e('Type', 'dagt'); ?></th>
                                <td>
                                    <select class="daext-visibility-hidden" id="type" name="type">
                                        <option value="1" <?php selected($test_obj->type, 1); ?>><?php esc_attr_e('Public Test', 'dagt'); ?></option>
                                        <option value="2" <?php selected($test_obj->type, 2); ?>><?php esc_attr_e('Free Practice', 'dagt'); ?></option>
                                        <option value="3" <?php selected($test_obj->type, 3); ?>><?php esc_attr_e('Practice', 'dagt'); ?></option>
                                        <option value="4" <?php selected($test_obj->type, 4); ?>><?php esc_attr_e('Examination', 'dagt'); ?></option>
                                    </select>
                                    <div class="help-icon" title="<?php esc_attr_e('The type of test.', 'dagt'); ?>"></div>
                                </td>
                            </tr>

                        </table>

                        <!-- submit button -->
                        <div class="daext-form-action">
                            <input class="button" type="submit" value="<?php esc_attr_e('Update Test', 'dagt'); ?>" >
                            <input id="cancel" class="button" type="submit" value="<?php esc_attr_e('Cancel', 'dagt'); ?>">
                        </div>

                <?php else : ?>

                    <!-- Create New Test -->

                    <div class="daext-form-container">

                        <div class="daext-form-title"><?php esc_attr_e('Create New Test', 'dagt'); ?></div>

                             <table class="daext-form">

                                <!-- Title -->
                                <tr valign="top">
                                    <th scope="row"><label for="keyword"><?php esc_attr_e('Title', 'dagt'); ?></label></th>
                                    <td>
                                        <input type="text" id="title" maxlength="255" size="30" name="title" autocomplete="off" />
                                        <div class="help-icon" title="<?php esc_attr_e('The title of the test.', 'dagt'); ?>"></div>
                                    </td>
                                </tr>

                                <!-- Description -->
                                <tr valign="top">
                                    <th scope="row"><label for="keyword"><?php esc_attr_e('Description', 'dagt'); ?></label></th>
                                    <td>
                                        <input type="text" id="description" maxlength="1000" size="30" name="description" autocomplete="off" />
                                        <div class="help-icon" title="<?php esc_attr_e('The description of the test.', 'dagt'); ?>"></div>
                                    </td>
                                </tr>

                                <!-- Section 1 to 10 -->
                                <?php

                                for($i=1;$i<=10;$i++){

                                    ?>

                                    <tr>
                                        <th scope="row"><?php esc_attr_e('Section', 'dagt'); ?> <?php echo $i; ?></th>
                                        <td>

                                             <select class="daext-visibility-hidden" id="section<?php echo $i; ?>_id" name="section<?php echo $i; ?>_id">

                                                 <option value="0"><?php esc_attr_e('Empty', 'dagt'); ?></option>

                                                 <?php

                                                 global $wpdb;
                                                 $table_name = $wpdb->prefix . $this->shared->get('slug') . "_section";
                                                 $sql = "SELECT * FROM $table_name ORDER BY id DESC";
                                                 $sections_a = $wpdb->get_results($sql, ARRAY_A);

                                                 foreach ($sections_a as $key => $single_section) {
                                                     echo '<option value="' . $single_section['id'] .'">' . esc_attr(stripslashes($single_section['title'])) . '</option>';
                                                 }

                                                 ?>

                                             </select>
                                            <div class="help-icon" title="<?php esc_attr_e('The section of the test.', 'dagt'); ?>"></div>

                                        </td>
                                    </tr>

                                    <?php

                               }

                               ?>


                                <!-- Additional Info -->
                                <tr valign="top">
                                    <th scope="row"><label for="additional_info"><?php esc_attr_e('Additional Information', 'dagt'); ?></label></th>
                                    <td>
                                        <input type="text" id="additional_info" maxlength="255" size="30" name="additional_info" autocomplete="off" />
                                        <div class="help-icon" title="<?php esc_attr_e('Optional additional information displayed in the bottom section of the test.', 'dagt'); ?>"></div>
                                    </td>
                                </tr>

                                <!-- Type -->
                                <tr>
                                    <th scope="row"><?php esc_attr_e('Type', 'dagt'); ?></th>
                                    <td>
                                        <select class="daext-visibility-hidden" id="type" name="type">
                                            <option value="1"><?php esc_attr_e('Public Test', 'dagt'); ?></option>
                                            <option value="2"><?php esc_attr_e('Free Practice', 'dagt'); ?></option>
                                            <option value="3"><?php esc_attr_e('Practice', 'dagt'); ?></option>
                                            <option value="4"><?php esc_attr_e('Examination', 'dagt'); ?></option>
                                        </select>
                                        <div class="help-icon" title="<?php esc_attr_e('The type of test.', 'dagt'); ?>"></div>
                                    </td>
                                </tr>

                            </table>

                            <!-- submit button -->
                            <div class="daext-form-action">
                                <input class="button" type="submit" value="<?php esc_attr_e('Add Test', 'dagt'); ?>" >
                            </div>

                        <?php endif; ?>

                    </div>

            </form>

        </div>

    </div>