<?php

/*
 * This file dynamically generates the svg ajax loader based on the color and on
 * the size specified with the plugin options
 */

//get data
if(!isset($_GET['color'])){die("color isn't set");}else{$color = $_GET['color'];}
if(!isset($_GET['size'])){die("size isn't set");}else{$size = intval($_GET['size'], 10);}

//validation
if(!preg_match('/^(?:[0-9a-fA-F]{3}){1,2}$/', $color)){die('Invalid Hex RGB color.');}

//set the content type as a image/svg+xml
header('Content-type: image/svg+xml');

//turn on output buffering
ob_start();

?>
<?php echo '<?xml version="1.0" encoding="utf-8"?>'; ?>
<svg xmlns="http://www.w3.org/2000/svg" width="33px" height="33px" viewBox="0 0 100 100" preserveAspectRatio="xMidYMid" class="uil-default">
<rect x="0" y="0" width="100" height="100" fill="none" class="bk"/>
<rect x="46.5" y="40" width="7" height="20" rx="5" ry="5" fill="#000000" transform="rotate(0 50 50) translate(0 -30)">
    <animate attributeName="opacity" from="1" to="0" dur="1s" begin="0s" repeatCount="indefinite"/>
</rect>
<rect x="46.5" y="40" width="7" height="20" rx="5" ry="5" fill="#000000" transform="rotate(30 50 50) translate(0 -30)">
    <animate attributeName="opacity" from="1" to="0" dur="1s" begin="0.08333333333333333s" repeatCount="indefinite"/>
</rect>
<rect x="46.5" y="40" width="7" height="20" rx="5" ry="5" fill="#000000" transform="rotate(60 50 50) translate(0 -30)">
    <animate attributeName="opacity" from="1" to="0" dur="1s" begin="0.16666666666666666s" repeatCount="indefinite"/>
</rect>
<rect x="46.5" y="40" width="7" height="20" rx="5" ry="5" fill="#000000" transform="rotate(90 50 50) translate(0 -30)">
    <animate attributeName="opacity" from="1" to="0" dur="1s" begin="0.25s" repeatCount="indefinite"/>
</rect>
<rect x="46.5" y="40" width="7" height="20" rx="5" ry="5" fill="#000000" transform="rotate(120 50 50) translate(0 -30)">
    <animate attributeName="opacity" from="1" to="0" dur="1s" begin="0.3333333333333333s" repeatCount="indefinite"/>
</rect>
<rect x="46.5" y="40" width="7" height="20" rx="5" ry="5" fill="#000000" transform="rotate(150 50 50) translate(0 -30)">
    <animate attributeName="opacity" from="1" to="0" dur="1s" begin="0.4166666666666667s" repeatCount="indefinite"/>
</rect>
<rect x="46.5" y="40" width="7" height="20" rx="5" ry="5" fill="#000000" transform="rotate(180 50 50) translate(0 -30)">
    <animate attributeName="opacity" from="1" to="0" dur="1s" begin="0.5s" repeatCount="indefinite"/>
</rect>
<rect x="46.5" y="40" width="7" height="20" rx="5" ry="5" fill="#000000" transform="rotate(210 50 50) translate(0 -30)">
    <animate attributeName="opacity" from="1" to="0" dur="1s" begin="0.5833333333333334s" repeatCount="indefinite"/>
</rect>
<rect x="46.5" y="40" width="7" height="20" rx="5" ry="5" fill="#000000" transform="rotate(240 50 50) translate(0 -30)">
    <animate attributeName="opacity" from="1" to="0" dur="1s" begin="0.6666666666666666s" repeatCount="indefinite"/>
</rect>
<rect x="46.5" y="40" width="7" height="20" rx="5" ry="5" fill="#000000" transform="rotate(270 50 50) translate(0 -30)">
    <animate attributeName="opacity" from="1" to="0" dur="1s" begin="0.75s" repeatCount="indefinite"/>
</rect>
<rect x="46.5" y="40" width="7" height="20" rx="5" ry="5" fill="#000000" transform="rotate(300 50 50) translate(0 -30)">
    <animate attributeName="opacity" from="1" to="0" dur="1s" begin="0.8333333333333334s" repeatCount="indefinite"/>
</rect>
<rect x="46.5" y="40" width="7" height="20" rx="5" ry="5" fill="#000000" transform="rotate(330 50 50) translate(0 -30)">
    <animate attributeName="opacity" from="1" to="0" dur="1s" begin="0.9166666666666666s" repeatCount="indefinite"/>
</rect>
</svg>
<?php

$output = ob_get_clean();

//replace the default color #000000 with the provided color
$output = str_replace('#000000', '#' . $color, $output);

//replace the default size with the provided size
$output = str_replace('33px', $size . 'px', $output);

//output the svg
echo $output;
die();